/*
   Copyright (C) 2007 - 2009 by Roberto García Carvajal <roberpot@gmail.com>
   Part of libglsws (http://magiccards.wordpress.com)

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License version 3
   or at your option any later version.
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY.

   See the COPYING file for more details.
*/

#include <GL/gl.h>
#include <string>
#include <map>
#include "sv_excepciones.h"

using namespace std;

#ifndef _C_SV_DATOS_
#define _C_SV_DATOS_


#define _T_DATO_BOOL   1
#define _T_DATO_INT    2
#define _T_DATO_STRING 3
#define _T_DATO_PAIR   4

class c_dato
{
 public:
  c_dato(){};
  void setb(bool b) { _bool = b; _t_dato = _T_DATO_BOOL; }
  void seti(GLint i) { _int = i; _t_dato = _T_DATO_INT; }
  void sets(string s) { _string = s; _t_dato = _T_DATO_STRING; }
  void setp(GLint i,string s) { _pair.first = i; _pair.second = s; _t_dato = _T_DATO_PAIR; }

  GLubyte t_dato() { return _t_dato; }

  bool b(){ return _bool; }
  GLint i(){ return _int; }
  string s(){ return _string; }
  pair<GLint,string> p(){ return _pair; }


 private:
  GLubyte _t_dato;
  bool _bool;
  GLint _int;
  string _string;
  pair<GLint,string> _pair;
};

class c_datos
{
 public:
  void insertar(GLuint i, c_dato dato);
  void eliminar(GLuint i);
  c_dato recuperar(GLuint i);
  bool existe(GLuint i);
 private:
  map<GLuint,c_dato> datos;
};

#endif
